/* cpp ata - still errors */
#include "biblosimpl.h"
#include "fielditem.h"

#include <qmessagebox.h>
#include <qpixmap.h>
#include <qpopupmenu.h>
#include <qtoolbutton.h>

FieldItem::FieldItem( QListViewItem *parent , QString caption )//for Collection creation
	:QListViewItem( parent , caption ){

  myField = new Field() ;
  Collection = NULL;
  setText( 0 , caption ) ; setText( 1 , " " ) ;
  myField->id='c';

  setPixmap( 0,uic_load_pixmap( "logo.png" ) );
  setRenameEnabled( 0 , TRUE );
  setRenameEnabled( 1 , TRUE );
  getField()->nextbrother=NULL;
  getField()->sons=NULL;
  getField()->llist=NULL;
  getField()->ltree=this;
  getField()->parent=NULL;
  
}

FieldItem::FieldItem( QListView *parent , QString acaption)// for LTree - Media and Collections creation
	:QListViewItem( parent ){

  myField = new Field() ;
  Collection = NULL;
  setText( 0 , acaption ) ; setText( 1 , " " ) ;



  myField->id='c';//from collections
  
  setRenameEnabled( 0 , FALSE );
  setRenameEnabled( 1 , FALSE );

  getField()->ltree = this ;
 
}

FieldItem::FieldItem( QListView *parent , Field *f , bool retainlist ,FieldItem *col)// for LList,RCL,LFind
	:QListViewItem( parent ){

QString l,ll;

  myField = new Field(f->id,f->name,f->size,f->time,f->date,f->uid,f->gid,f->user,f->group,f->perm,f->comment,f->collectionslist) ;
  Collection = col;


  setText( 0 , f->name );
  if( retainlist ){

    myField->llist = (FieldItem *)this ;

    setText( 1 , f->size );
    setText( 2 , f->time +  " " + f->date  );
    setText( 3 , f->user + "/" + f->group + " (" + f->uid + "/" + f->gid + ")"  );

    setText( 4 , f->perm );
    setText( 5 , f->comment );

    setRenameEnabled( 5 , TRUE );
  }
  else
    {//for ECL
    
	
	 for(Field *t = f->parent ; t != NULL ; t = t->parent ) {
	     ll = l;
		 l = t->name ;
#ifdef Q_WS_WIN
		 l += "\\" ;
#else
	     l += "/" ;
#endif
	     l += ll;
	 }
	 setText( 1 ,l );
	
	 setText( 2 , f->size );
	 setText( 3 , f->time +  " " + f->date  );
     //setText( 3 , (const char *)tmp1 );
     setText( 4 , f->user + "/" + f->group + " (" + f->uid + "/" + f->gid + ")"  );
     //setText( 4 , (const char *)tmp2 );
	 setText( 5 , f->perm );
	 setText( 6 , f->comment );
   setRenameEnabled( 6 , TRUE );
    }

    if( f->id == 'd' ||  f->id == 'v')
//	setPixmap( 0 , *IconDirClosed );
    setPixmap( 0,uic_load_pixmap( "i-directory.png" ) );
    else
    setPixmap( 0,uic_load_pixmap( "i-regular.png" ) );
//	setPixmap( 0 , *IconFileRegular );

}

FieldItem::FieldItem( FieldItem *parent , Field *f ,bool retainlist , FieldItem *col)	// for LTree creation
	:QListViewItem( parent ){


  myField = f ;
  Collection = col ;

  setText( 0 , f->name ) ; setText( 1 , f->comment ) ;

  setPixmap( 0,uic_load_pixmap( "i-directory.png" ) );
  setRenameEnabled( 1 , TRUE );

  if( retainlist ) myField->ltree = (FieldItem *)this ;


  if( myField->sons != NULL )
    for( Field *lst = myField->sons ; lst != NULL ; lst = lst->nextbrother )
	  if( lst->id == 'd' ){
		if( col != NULL )
		  if( lst->collectionslist.contains("\""+col->text(0)+"\"") == 0 ) continue ;
        (void)new FieldItem( this , lst , retainlist , col  ) ;
      }



  //if( myField->nextbrother != NULL && myField->id=='v')
//	  (void)new FieldItem( parent , myField->nextbrother , retainlist ,col ) ;

}



void FieldItem::FillCollections(Field *item){
//takes as argument a tree and fills the collections accordingly

	if( item->collectionslist.length() != 0 )
	  fetchCollection(item);

	if( item->sons != NULL ) 
		for(Field *it=item->sons;it;it=it->nextbrother)
			FillCollections(it);//recursing sons for new collections
	if( item->nextbrother!= NULL && item->id=='v' )
      FillCollections( item->nextbrother ) ;

}
void FieldItem::fetchCollection(Field *item){
  FieldItem *col_ptr=NULL;
  char *col=strtok((char *)(item->collectionslist.latin1()),"\"");


  while(col!=NULL){

    if(col[strlen(col)-1]!='#'){//this item is not a top item in a collection - its tree is added by its parent
      col=strtok(NULL,"\"");
      continue;
    } else 
        col[strlen(col)-1]='\0';

    //QMessageBox::message("addToCollections",col);
    col_ptr = NULL;//out of order listing
    //vedem daca colectia a fost deja creata
    for( QListViewItemIterator *it=new QListViewItemIterator(LCollections->firstChild()) ; it->current()!=NULL ; ++(*it) ){
      if(it->current()->parent()==LCollections)
	//pizda ma~tii de ++(*it) - retard pointer to class - mi-a luat 4 ore sa vad eroarea
	//QMessageBox::message("addToCollections",it->current()->text(0));
	if( !strcmp(col,it->current()->text(0).latin1() ) ) {
          col_ptr=(FieldItem *)it->current();
	  break;
	}
    }


    //QMessageBox::message("addToCollections","item named "+ item->name);
    //daca nu a fost creeata o creem
    if(col_ptr == NULL){
      col_ptr=new FieldItem( LCollections , col );
      MyForm->BAddMToCol->popup()->insertItem(col,MyForm,SLOT(Obj_addToCollection(int)),0,-1,-1);
    }

    FieldItem *temp=new FieldItem( (FieldItem *)(col_ptr) , item , FALSE ,col_ptr);//from ltree
    col=strtok(NULL,"\"");
  }

//free(cl);
}
