/* cpp at */
#include "biblosimpl.h"
#include "easycopylist.h"

#include <string.h>

#include <qbuttongroup.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qdatetimeedit.h>
#include <qlabel.h>
#include <qlineedit.h>
#include <qlistview.h>
#include <qmessagebox.h>



void TFindDialog::DateEnabled( bool t )
{
 DateSelect->setEnabled( DateToggle->isChecked() ) ;
 DateNumber1->setEnabled( DateToggle->isChecked() ) ;
 DateAnd->setEnabled( DateSelect->currentItem() == 3 && t ) ;
 DateNumber2->setEnabled( DateSelect->currentItem() == 3 && t ) ;
}
void TFindDialog::DateBetweenEnabled( int sel )
{
 if( sel != 3 ) 
   {
     DateAnd->setEnabled( FALSE );
     DateNumber2->setEnabled( FALSE );
   }
 else
   {
     DateAnd->setEnabled( TRUE );
     DateNumber2->setEnabled( TRUE );
   }
}

void TFindDialog::Obj_toECL_fromF()
{QListViewItem *it ;

 MyForm->MyEasyCopyList.show();
 
  for(it = LFind->firstChild() ; it ; it = it->nextSibling() )
    if( LFind->isSelected( it ) && ((((FieldItem *)(it))->getField())->lecl == NULL) )
      MyForm->MyEasyCopyList.LECL->insertItem( (((FieldItem *)(it))->getField())->lecl =
        new FieldItem( MyForm->MyEasyCopyList.LECL ,((FieldItem *)(it))->getField() , FALSE , NULL ) ) ;
     //attn

}


void TFindDialog::TestConditions( Field *tree )
{unsigned long ul1;
 unsigned int ui1;
 bool ok = FALSE;
 QDate D1;

  if( !Name->currentText().isNull() && !Name->currentText().isEmpty() )
    if( QString(tree->name).find(Name->currentText(),0,FALSE) == -1 ) return ;


  if( SizeToggle->isChecked() )
    {
     sscanf( tree->size , "%u" , &ul1 );

     switch( SizeSelect->currentItem() ){
       case 0 : // size>=
                if( ul1 < SizeNumber->text().toULong( &ok , 10 ) ) return; break;
       case 1 : // size=
                if( ul1 != SizeNumber->text().toULong( &ok , 10 ) ) return; break;
       case 2 : // size<=
                if( ul1 > SizeNumber->text().toULong( &ok , 10 ) ) return; break;
        };
    }

  if( DateToggle->isChecked() )
    {
     D1 = QDate::fromString(tree->date , Qt::TextDate );
//assert : date1<date2
     switch( DateSelect->currentItem() ){
       case 0 : // date<=
                if( D1 > DateNumber1->date() ) return; break;
       case 1 : // date=
                if( D1 != DateNumber1->date() ) return; break;
       case 2 : // date>=
                if( D1 < DateNumber1->date() ) return; break;
       case 3 : // date1<=date<=date2
                if( D1 < DateNumber1->date() || D1 > DateNumber2->date() ) return; break;
        };
    }

  if( UserToggle->isChecked() )
    if( strcmp( tree->user , (const char *)UserName->text() ) ) return ;
  if( GroupToggle->isChecked() )
    if( strcmp( tree->group , (const char *)GroupName->text() ) ) return ;

  if( UidToggle->isChecked() )
    {
     sscanf( tree->uid , "%u" , &ui1 );
     if( ui1 != UidNumber->text().toULong( &ok ,10 ) ) return ;
    }
  if( GidToggle->isChecked() )
    {
     sscanf( tree->gid , "%u" , &ui1 );
     if( ui1 != GidNumber->text().toULong( &ok ,10 ) ) return ;
    }

  if( PermToggle->isChecked() )
    {
     sscanf( tree->perm , "%u" , &ul1 );

     switch( PermSelect->currentItem() ){
       case 0 : // size>=
                if( ul1 < PermNumber->text().toULong( &ok , 10 ) ) return; break;
       case 1 : // size=
                if( ul1 != PermNumber->text().toULong( &ok , 10 ) ) return; break;
       case 2 : // size<=
                if( ul1 > PermNumber->text().toULong( &ok , 10 ) ) return; break;
        };
    }
          
  if( CommentToggle->isChecked() )
    if( strstr( tree->comment , (const char *)CommentText->text() ) == NULL ) return ;

  //if(
 new FieldItem( (QListView *)LFind , tree , FALSE , NULL );
    
}
  
void TFindDialog::FindInTree( Field *tree )
{
  while( tree != NULL )
    {
     TestConditions( tree );  
     if( Recurse->isChecked() ) FindInTree( tree->sons ) ;
     tree = tree->nextbrother;
    }
}

void TFindDialog::Search(void){

  ButtonGroup2->setEnabled( FALSE );
  Name->setEnabled( FALSE );
  Recurse->setEnabled( FALSE );
  LFind->clear();
 
  if( SizeNumber->text().isNull() || SizeNumber->text().isEmpty() ) SizeToggle->setChecked( FALSE ) ;
  if( DateSelect->currentItem() == 4 && DateNumber1->date() > DateNumber2->date() ) return ;
  if( UserName->text().isNull() || UserName->text().isEmpty() ) UserToggle->setChecked( FALSE ) ;
  if( GroupName->text().isNull() || GroupName->text().isEmpty() ) GroupToggle->setChecked( FALSE ) ;
  if( UidNumber->text().isNull() || UidNumber->text().isEmpty() ) UidToggle->setChecked( FALSE ) ;
  if( GidNumber->text().isNull() || GidNumber->text().isEmpty() ) GidToggle->setChecked( FALSE ) ;
  if( PermNumber->text().isNull() || PermNumber->text().isEmpty() ) PermToggle->setChecked( FALSE ) ;
  if( CommentText->text().isNull() || CommentText->text().isEmpty() ) CommentToggle->setChecked( FALSE ) ;

  if( MyForm->LTree->selectedItem() != NULL )
    if( ((FieldItem *)(MyForm->LTree->selectedItem()))->getField()->sons != NULL )
      FindInTree( ((FieldItem *)(MyForm->LTree->selectedItem()))->getField()->sons );
	else 
		for(QListViewItemIterator *it=new QListViewItemIterator(MyForm->LTree->selectedItem());it->current()!=NULL;++(*it))
		  if( it->current()->parent() == MyForm->LTree->selectedItem() )
			  FindInTree( ((FieldItem *)( it->current()))->getField()->sons );
		  else ;
  else if( (MyForm->LList->selectedItem() != NULL) )
    FindInTree( ((FieldItem *)(MyForm->LList->selectedItem()))->getField()->sons );
  else QMessageBox::warning(this,tr("Warning"),tr("Please select in the main window a directory to search in !"),
	  QMessageBox::Ok,0,0);

  ButtonGroup2->setEnabled( TRUE );
  Name->setEnabled( TRUE );
  Recurse->setEnabled( TRUE );
                
}

void TFindDialog::BrowseDir( QListViewItem *itchanged ){

  if( ((FieldItem *)(itchanged))->getField()->ltree == NULL ) return;
  MyForm->LTree_selectionChanged( ((FieldItem *)(itchanged))->getField()->ltree );
  MyForm->LTree->setSelected( ((FieldItem *)(itchanged))->getField()->ltree,TRUE);
  MyForm->LTree->ensureItemVisible( ((FieldItem *)(itchanged))->getField()->ltree);
  MyForm->LTree->setOpen( ((FieldItem *)(itchanged))->getField()->ltree,TRUE);
  MyForm->setFocus();
}
