#ifndef __FIELDITEM_H__
#define __FIELDITEM_H__

#include <qobject.h>
#include <qlistview.h>
#include <qmessagebox.h>
#include "biblosimpl.h"

class Field;
class TForm;
extern TForm *MyForm;

class FieldItem : public QObject, public QListViewItem{

	Q_OBJECT

  Field *myField;

public:
  FieldItem( QListView *parent , QString caption );
  FieldItem( QListViewItem *parent , QString caption );
  FieldItem( QListView *parent , Field *f , bool retainlist ,FieldItem *col);//llist
  FieldItem( FieldItem *parent , Field *f , bool retainlist , FieldItem *collection);//ltree

  void FillCollections(Field *item);
  void fetchCollection(Field *item);

  Field *getField(){ return myField ; }
  void setField(Field *f){ myField = f ; }
  FieldItem *Collection;
  //FieldItem *files;

  ~FieldItem(){
     //QMessageBox::warning((QWidget *)MyForm , "","destructor of an FIELDITEM in  " + text(0) , QMessageBox::Ok,0,0);
  }

};

#endif /* __FIELDITEM_H__ */
