/* c++ - ed
always ready */
#include <qapplication.h>
#include <qtranslator.h>
#include <qsettings.h>
#include "biblosimpl.h"

TForm *MyForm;
QApplication *a;
QTranslator *MyTranslator;


int main( int argc, char ** argv ) 
{

     a=new QApplication( argc, argv );

	QSettings settings;
#ifdef Q_WS_WIN
    settings.insertSearchPath( QSettings::Windows, "/Biblos" );
#endif

    MyTranslator=new QTranslator( 0 );
    MyTranslator->load( settings.readEntry( "/biblos/lang file", "/opt/biblos/biblos_en" ) , "." );
    a->installTranslator( MyTranslator );

    MyForm = new TForm;
    MyForm->hide();


    a->connect( a, SIGNAL(lastWindowClosed()), a, SLOT(quit()) );
    return a->exec();
}

