/* c++ - ed 
 error free !!! */
#include "biblosimpl.h"

#include <stdlib.h>

#include <qfile.h>
#include <qfiledialog.h>
#include <qstatusbar.h>
#include <qtextstream.h>
#include <string.h>

void TForm::IDXFile_SaveAs()
{
   QString OldFileName(FileName);
   FileName.truncate(0);
   if( !IDXFile_Save() ) FileName=OldFileName;
}
 
int TForm::IDXFile_Save()
{
  //qWarning("saving file");
  if( FileName.isEmpty() )
    {
     FileName += QFileDialog::getSaveFileName( QString::null, "*.idx", this ) ;
     if ( FileName.isEmpty() )
       {qWarning("IDXFile_Save():string null") ; return 0 ;} // name not changed
    }
//qWarning("file choosed");
  QFile f( FileName );
  if( !f.open( IO_WriteOnly ) ) return 0;

//qWarning("file opened");
  QTextStream tstream( &f ) ;
  tstream << "IDX";
  //qWarning("writing file");
  WriteIDXFile( &tstream , BaseTree ) ;

  f.close() ;
  statusBar()->clear();

 return 1;
}

void TForm::WriteIDXFile( QTextStream *tstream , Field *tree )
{
     
 while( tree != NULL ){
   *tstream << "\n" ;
   *tstream << tree->id << "\t\"" << tree->name << "\"\t" ;
   *tstream << tree->size << "\t" ;
   *tstream << tree->time << "\t" << tree->date << "\t" ;
   *tstream << tree->uid << "\t" << tree->gid << "\t" ;
   *tstream << tree->user << "\t" << tree->group << "\t" ;
   *tstream << tree->perm << "\t\"" ;
   *tstream << tree->comment << "\"\t" ;
   if( tree->collectionslist.length() != 0 ){
	 tree->collectionslist.truncate(tree->collectionslist.length()-1);
	 tree->collectionslist+="\"";//idiot error - if not concats " str is truncated at the second "
	 *tstream << tree->collectionslist << "\t" ;
	 //QMessageBox::warning(this,"",tree->collectionslist,QMessageBox::Ok,0,0);
}
	  

   if( tree->id == 'd' || tree->id == 'v' ) 
	   statusBar()->message( tree->name ) ;

   if( tree->sons != NULL ){
      *tstream << "\\" ;	  
      WriteIDXFile( tstream , tree->sons ) ;
      *tstream << "/" ;
     }
   
   tree = tree->nextbrother ;
  }
}