/* c++ - ed
still to work on language switch*/
#include "biblosimpl.h"
#include <qapplication.h>
#include <qcheckbox.h>
#include <qcombobox.h>
#include <qdatetimeedit.h>
#include <qlabel.h>
#include <qlistview.h>
#include <qmessagebox.h>
#include <qpopupmenu.h>
#include <qtoolbutton.h>
#include <qsettings.h>

void TForm::LTree_unFocused()
{
  LTree->clearSelection();
}
void TForm::LList_unFocused()
{
  LList->clearSelection();
}

void TForm::About(){
 QMessageBox mb;
 char text[256]; 
 strcpy( text , "  Biblos 0.35 ");
 strcat( text , tr("- media indexing program\nWritten by ") );
 strcat( text , "Vasile Dumitrascu ( va511e@yahoo.com )\n");
 strcat( text, tr(" QT version : " ) );
 strcat( text , qVersion() );
 strcat( text , tr("\nVisit http://biblos.f2g.net for updates") ); 
 mb.information( this , tr("About") , text );
}

void TForm::Form1_Exit(){
        qApp->quit();   
}
void TForm::toggleLang(int id){
	QMessageBox mb;
	


	for(int i=0;i<4;i++)
	  if(id == i){
		
		BLang->popup()->setItemChecked(id,true);
			
			
		QSettings settings;
#ifdef Q_WS_WIN
		settings.insertSearchPath( QSettings::Windows, "/Biblos" );
#endif
		// No search path needed for Unix; see notes further on.
		
		switch(id){
		  case 0: settings.writeEntry( "/biblos/lang file", "/opt/biblos/biblos_en" );break;
		  case 1: settings.writeEntry( "/biblos/lang file", "/opt/biblos/biblos_ro" );break;
		}
		mb.information( this , tr("Language changed") , tr("The settings will be available the next time you start Biblos") );	
	  }else 
		BLang->popup()->setItemChecked(i,false);
}

